/*
 * Copyright (c) 1990,1993 Regents of The University of Michigan.
 * All Rights Reserved.  See COPYRIGHT.
 */

# ifndef _AFPD_CONF
#define _AFPD_CONF

/*
 * The UAMs (User Authentication Method) are used by the Chooser to log
 * you into your Unix machine to use the filesystem.  If you want to add
 * your own UAM, look in auth.c.
 */
#define CLRTXTUAM	/* add clear text (Kerberos or passwd) authentication */

/*
 * Unix <-> Mac translations. If you define DOWNCASE, all Mac filenames
 * will be mapped to lowercase Unix filenames. This produces a case-
 * insensative filesystem. Unfortunately, it also means that Unix
 * filename that already have mixed case will be inaccessible.
 *
 * CRLF turns on carrage return <-> line feed translation. This means
 * that Mac files that are of type TEXT may be edited with vi on Unix,
 * and that Unix text file may be editted with "you favorite Mac editor".
 */
/* #define DOWNCASE	/* downcase all filenames (see Caveats) */
#define CRLF		/* do cr <-> lf translation of TEXT files */

/* 
 * If you want AFS, you must have KRBUAM and AFSACL turned on. There
 * is Mac side code available to exercise these options.
 */
#ifdef AFS
# ifndef AFSACL
#  define AFSACL
# endif
# ifndef KRBUAM
#  define KRBUAM
# endif
# ifndef AFSCHANGEPW
#  define AFSCHANGEPW
# endif
#endif AFS

# endif _AFPD_CONF
